/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.unterstuetzer.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="EINTRAGUNGSLISTE.MaxNummer",
     query="SELECT MAX(obj.nummer) FROM Eintragungsliste obj WHERE obj.wahlvorschlag.gruppeImGebiet.gruppe.wahl = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="EINTRAGUNGSLISTE.Wahl",
     query="SELECT obj FROM Eintragungsliste obj WHERE wahlvorschlag.gruppeImGebiet.gruppe.wahl = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="EINTRAGUNGSLISTE.WahlvorschlagAndNummer",
     query="SELECT DISTINCT obj FROM Eintragungsliste obj WHERE obj.wahlvorschlag = ?1 AND obj.nummer = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="EINTRAGUNGSLISTE.Wahlvorschlag",
     query="SELECT obj FROM Eintragungsliste obj WHERE obj.wahlvorschlag = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "EINTRAGUNGSLISTE")
// @javax.persistence.IdClass(EintragungslistePK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Eintragungsliste
extends AbstractEintragungsliste
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Eintragungsliste() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Eintragungsliste(Eintragungsliste original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "eintragungsliste_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Eintragungsliste")
    @javax.persistence.TableGenerator(name = "Eintragungsliste", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Eintragungsliste", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient EintragungslistePK pkCache;

  @Override
  public EintragungslistePK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new EintragungslistePK(getId());
    }

    return pkCache;
  }

  public static <E extends Eintragungsliste> java.util.Map<EintragungslistePK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<EintragungslistePK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Eintragungsliste> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedNummer = false;
  
      hasChangedWahlvorschlag = false;
  

          hasChangedEintragungslisteEintragsByEintragungsliste = false;
      
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Column(name = "NUMMER", nullable = EintragungslisteConstants.NUMMER_NULLABLE, precision=EintragungslisteConstants.NUMMER_PRECISION, scale=EintragungslisteConstants.NUMMER_SCALE)
            
  protected java.lang.Long nummer =  null;

  @javax.persistence.Transient
  protected boolean hasChangedNummer = false;

  public boolean hasChangedNummer(){
    return hasChangedNummer;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertNummer = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenNummer;
  
  /**
   * 
   *
   * getter for EINTRAGUNGSLISTE.NUMMER
   */
    @Override   public  java.lang.Long getNummer() {
        return nummer;
      }

  /**
   * 
   *
   * setter for EINTRAGUNGSLISTE.NUMMER
   *
   * @param nummer
   */
  @Override   public void setNummer( java.lang.Long nummer) {

       resetTkCache();
                  java.lang.Long nummerInternal = nummer;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.nummer
      , nummerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedNummer |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("nummer");
      }


             if (!isSeitLadenVeraendertNummer) {
          isSeitLadenVeraendertNummer = thisAttributChanged;
         if (isSeitLadenVeraendertNummer){
           wertNachLadenNummer=this.nummer;
         }
       }
      

       this.nummer = nummerInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Wahlvorschlag
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHLVORSCHLAG_ID", referencedColumnName="WAHLVORSCHLAG_ID"))
  protected de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag wahlvorschlag;

  /**
   * 
   */
  @Override
  public void setWahlvorschlag( de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag wahlvorschlag){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahlvorschlag
    , wahlvorschlag);

    attributeChanged |= thisAttributChanged;

    hasChangedWahlvorschlag |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahlvorschlag");
    }

    this.wahlvorschlag = wahlvorschlag;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag getWahlvorschlag(){
    return this.wahlvorschlag;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahlvorschlag = false;

  public boolean hasChangedWahlvorschlag(){
    return hasChangedWahlvorschlag;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehung 1:N (bidirektional) zu EintragungslisteEintragsByEintragungsliste
   *
   */
  @javax.persistence.OneToMany(targetEntity=de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag.class, mappedBy="eintragungsliste", fetch=javax.persistence.FetchType.LAZY )
// deaktiviert, gibt Probleme beim Löschen  @org.hibernate.annotations.Cache(usage = org.hibernate.annotations.CacheConcurrencyStrategy.TRANSACTIONAL)
  protected java.util.Set<de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag> eintragungslisteEintragsByEintragungsliste;


  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  
  @Override
  public java.util.Set<de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag> getEintragungslisteEintragsByEintragungsliste(){
    if (eintragungslisteEintragsByEintragungsliste == null){
      return  java.util.Collections.<de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag>emptySet());
    }

    return java.util.Collections.<de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag>unmodifiableSet(this.eintragungslisteEintragsByEintragungsliste);
  }

  @javax.persistence.Transient
  private boolean hasChangedEintragungslisteEintragsByEintragungsliste = false;

  public boolean hasChangedEintragungslisteEintragsByEintragungsliste() {
    return hasChangedEintragungslisteEintragsByEintragungsliste;
  }

  /**
   * Hinzufuegen von de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag
   */
  @Override
  public void addEintragungslisteEintragByEintragungsliste(de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag eintragungslisteEintragByEintragungsliste){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (eintragungslisteEintragByEintragungsliste != null){
          if (this.eintragungslisteEintragsByEintragungsliste == null) {
            this.eintragungslisteEintragsByEintragungsliste = new java.util.HashSet<>();
          }

          boolean isChanged = this.eintragungslisteEintragsByEintragungsliste.add(eintragungslisteEintragByEintragungsliste);

          if(!hasChangedEintragungslisteEintragsByEintragungsliste) {
            hasChangedEintragungslisteEintragsByEintragungsliste =  isChanged;
          }

          // andere Seite der Beziehung aktualisieren
          eintragungslisteEintragByEintragungsliste.setEintragungsliste(this);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag
   */
  @Override
  public void removeEintragungslisteEintragByEintragungsliste(de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag eintragungslisteEintragByEintragungsliste){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (eintragungslisteEintragByEintragungsliste != null){
          if (this.eintragungslisteEintragsByEintragungsliste != null) {
            boolean isChanged = this.eintragungslisteEintragsByEintragungsliste.remove(eintragungslisteEintragByEintragungsliste);

            if(!hasChangedEintragungslisteEintragsByEintragungsliste) {
              hasChangedEintragungslisteEintragsByEintragungsliste =  isChanged;
            }
          }

          // andere Seite der Beziehung aktualisieren
          eintragungslisteEintragByEintragungsliste.setEintragungsliste(null);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag
  */
   @Override
   public void removeAllEintragungslisteEintragByEintragungslistes(){
     java.util.Set<de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag> toRemove = new java.util.HashSet<>(getEintragungslisteEintragsByEintragungsliste());

     for (   de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag entity:toRemove){
       removeEintragungslisteEintragByEintragungsliste(entity);
     }
   }

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Eintragungsliste:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Eintragungsliste other){
                             other.nummer = this.nummer;
           
  other.setWahlvorschlag(this.getWahlvorschlag());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Eintragungsliste.class)){
        copyEntityAttributesUsingSetter((Eintragungsliste) other.castTo(Eintragungsliste.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Eintragungsliste: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Eintragungsliste other){
               other.setNummer(this.nummer);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Eintragungsliste other){
                       if (hasChangedNummer) {
        other.setNummer(this.nummer);
      }
             }





    @javax.persistence.Transient
    private transient EintragungslisteTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public EintragungslisteTK getEintragungslisteTK(){
    if (tkCache==null) {
    tkCache = new EintragungslisteTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getEintragungslisteTK();
    }

  @Override
  public EintragungslisteUK getUk(){
    return getEintragungslisteUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Eintragungsliste.class;
  }

public EintragungslisteUK getEintragungslisteUK(){

   return  new EintragungslisteUK(



  );
}

  @javax.persistence.Transient
  private transient EintragungslisteProperties properties;

  public EintragungslisteProperties getProperties(){
    if (properties == null) {
      properties = new EintragungslisteProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public EintragungslisteProperties getEintragungslisteProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return EintragungslisteConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(EintragungslisteConstants.MESSAGE_KEY_NUMMER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(EintragungslisteConstants.MESSAGE_KEY_NUMMER_EINZAHL);

        nummer =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertNummer) {
      result.put(EintragungslisteConstants.MESSAGE_KEY_NUMMER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenNummer , nummer));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertNummer = false;
      wertNachLadenNummer = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "EINTRAGUNGSLISTE";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Eintragungsliste";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(nummer, this, EintragungslisteConstants.MESSAGE_KEY_NUMMER_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(EintragungslisteConstants.NUMMER_MAX_VALUE, EintragungslisteConstants.NUMMER_MIN_VALUE, nummer, this, EintragungslisteConstants.MESSAGE_KEY_NUMMER_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
